var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { isString } from 'lodash';
import React, { useContext, useId } from 'react';
import { usePrefixConfig } from '../../hooks';
import { DFormContext } from '../form';
function BaseInput(props, ref) {
    var _a, _b;
    const { dFormControl, dTag = 'input', dFor = true } = props, restProps = __rest(props, ["dFormControl", "dTag", "dFor"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    const formContext = useContext(DFormContext);
    //#endregion
    const uniqueId = useId();
    const id = (_a = restProps.id) !== null && _a !== void 0 ? _a : `${dPrefix}base-input-${uniqueId}`;
    const supportForm = formContext && dFormControl;
    const attrs = supportForm
        ? Object.assign({ 'data-form-label-for': dFor }, dFormControl.inputAttrs) : {};
    return React.createElement(dTag, Object.assign(Object.assign(Object.assign({}, restProps), attrs), { ref,
        id, 'aria-describedby': [props['aria-describedby'], (_b = dFormControl === null || dFormControl === void 0 ? void 0 : dFormControl.inputAttrs) === null || _b === void 0 ? void 0 : _b['aria-describedby']]
            .filter((describedby) => isString(describedby))
            .join(' ') }));
}
export const DBaseInput = React.forwardRef(BaseInput);
//# sourceMappingURL=BaseInput.js.map