import { useImmer } from '@react-devui/hooks';
export function useNestedPopup(initialValue = []) {
    const [popupIds, setPopupIds] = useImmer(() => initialValue.map((id) => ({ id, visible: true })));
    return {
        popupIds,
        setPopupIds,
        addPopupId: (id) => {
            setPopupIds((draft) => {
                if (draft.findIndex((v) => v.id === id) === -1) {
                    draft.push({ id, visible: true });
                }
            });
        },
        removePopupId: (id) => {
            setPopupIds((draft) => {
                const index = draft.findIndex((v) => v.id === id);
                if (index !== -1) {
                    draft[index].visible = false;
                    for (let index = draft.length - 1; index >= 0; index--) {
                        if (draft[index].visible) {
                            break;
                        }
                        draft.pop();
                    }
                }
            });
        },
    };
}
//# sourceMappingURL=hooks.js.map