var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import React, { useCallback, useImperativeHandle, useRef, useState } from 'react';
import { useEffect } from 'react';
import ReactDOM from 'react-dom';
import { useAsync, useElement, useForkRef } from '@react-devui/hooks';
import { CloseCircleFilled, DownOutlined, LoadingOutlined, SearchOutlined } from '@react-devui/icons';
import { checkNodeExist, getClassName } from '@react-devui/utils';
import { usePrefixConfig, useTranslation, useMaxIndex, useLayout } from '../../hooks';
import { TTANSITION_DURING_POPUP } from '../../utils';
import { DBaseDesign } from '../_base-design';
import { DBaseInput } from '../_base-input';
import { DFocusVisible } from '../_focus-visible';
import { DTransition } from '../_transition';
function Selectbox(props, ref) {
    const { children, dClassNamePrefix, dFormControl, dVisible = false, dContent, dContentTitle, dPlaceholder, dSuffix, dSize, dLoading = false, dSearchable = false, dClearable = false, dDisabled = false, dInputProps, dInputRef, dUpdatePosition, afterVisibleChange, onFocusVisibleChange, onClear } = props, restProps = __rest(props, ["children", "dClassNamePrefix", "dFormControl", "dVisible", "dContent", "dContentTitle", "dPlaceholder", "dSuffix", "dSize", "dLoading", "dSearchable", "dClearable", "dDisabled", "dInputProps", "dInputRef", "dUpdatePosition", "afterVisibleChange", "onFocusVisibleChange", "onClear"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    const { dScrollEl, dResizeEl } = useLayout();
    //#endregion
    //#region Ref
    const boxRef = useRef(null);
    const popupRef = useRef(null);
    const inputRef = useRef(null);
    //#endregion
    const prefix = `${dPrefix}${dClassNamePrefix}`;
    const combineInputRef = useForkRef(inputRef, dInputRef);
    const asyncCapture = useAsync();
    const [t] = useTranslation();
    const [isFocus, setIsFocus] = useState(false);
    const inputable = dSearchable && dVisible;
    const clearable = dClearable && dContent && !dVisible && !dLoading && !dDisabled;
    const scrollEl = useElement(dScrollEl);
    const resizeEl = useElement(dResizeEl);
    const containerEl = useElement(() => {
        let el = document.getElementById(`${prefix}-root`);
        if (!el) {
            el = document.createElement('div');
            el.id = `${prefix}-root`;
            document.body.appendChild(el);
        }
        return el;
    });
    const maxZIndex = useMaxIndex(dVisible);
    const [popupPositionStyle, setPopupPositionStyle] = useState({
        top: -9999,
        left: -9999,
    });
    const [transformOrigin, setTransformOrigin] = useState();
    const updatePosition = useCallback(() => {
        if (boxRef.current && popupRef.current) {
            const res = dUpdatePosition === null || dUpdatePosition === void 0 ? void 0 : dUpdatePosition(boxRef.current, popupRef.current);
            if (res) {
                setPopupPositionStyle(res.position);
                setTransformOrigin(res.transformOrigin);
            }
        }
    }, [dUpdatePosition]);
    useEffect(() => {
        if (dVisible) {
            const [asyncGroup, asyncId] = asyncCapture.createGroup();
            if (boxRef.current) {
                asyncGroup.onResize(boxRef.current, () => {
                    updatePosition();
                });
            }
            if (popupRef.current) {
                asyncGroup.onResize(popupRef.current, () => {
                    updatePosition();
                });
            }
            return () => {
                asyncCapture.deleteGroup(asyncId);
            };
        }
    }, [asyncCapture, dVisible, updatePosition]);
    useEffect(() => {
        if (dVisible && scrollEl) {
            const [asyncGroup, asyncId] = asyncCapture.createGroup();
            asyncGroup.fromEvent(scrollEl, 'scroll', { passive: true }).subscribe({
                next: () => {
                    updatePosition();
                },
            });
            return () => {
                asyncCapture.deleteGroup(asyncId);
            };
        }
    }, [asyncCapture, dVisible, scrollEl, updatePosition]);
    useEffect(() => {
        if (dVisible && resizeEl) {
            const [asyncGroup, asyncId] = asyncCapture.createGroup();
            asyncGroup.onResize(resizeEl, () => {
                updatePosition();
            });
            return () => {
                asyncCapture.deleteGroup(asyncId);
            };
        }
    }, [asyncCapture, dVisible, resizeEl, updatePosition]);
    const preventBlur = (e) => {
        if (e.target !== inputRef.current && e.button === 0) {
            e.preventDefault();
        }
    };
    useImperativeHandle(ref, () => ({
        updatePosition,
    }), [updatePosition]);
    return (_jsxs(_Fragment, { children: [_jsx(DBaseDesign, Object.assign({ dCompose: { active: isFocus, disabled: dDisabled }, dFormControl: dFormControl }, { children: _jsxs("div", Object.assign({}, restProps, { ref: boxRef, className: getClassName(restProps.className, prefix, {
                        [`${prefix}--${dSize}`]: dSize,
                        'is-expanded': dVisible,
                        'is-focus': isFocus,
                        'is-disabled': dDisabled,
                    }), onMouseDown: (e) => {
                        var _a;
                        (_a = restProps.onMouseDown) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                        preventBlur(e);
                    }, onMouseUp: (e) => {
                        var _a;
                        (_a = restProps.onMouseUp) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                        preventBlur(e);
                    }, onClick: (e) => {
                        var _a, _b;
                        (_a = restProps.onClick) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                        (_b = inputRef.current) === null || _b === void 0 ? void 0 : _b.focus({ preventScroll: true });
                    } }, { children: [_jsxs("div", Object.assign({ className: `${prefix}__container`, title: dContentTitle }, { children: [_jsx(DFocusVisible, Object.assign({ onFocusVisibleChange: onFocusVisibleChange }, { children: ({ fvOnFocus, fvOnBlur, fvOnKeyDown }) => (_jsx(DBaseInput, Object.assign({}, dInputProps, { ref: combineInputRef, className: getClassName(`${prefix}__search`, dInputProps === null || dInputProps === void 0 ? void 0 : dInputProps.className), style: Object.assign(Object.assign({}, dInputProps === null || dInputProps === void 0 ? void 0 : dInputProps.style), { opacity: inputable ? undefined : 0, zIndex: inputable ? undefined : -1 }), type: "text", autoComplete: "off", disabled: dDisabled, role: "combobox", "aria-haspopup": "listbox", "aria-expanded": dVisible, onFocus: (e) => {
                                            var _a;
                                            (_a = dInputProps === null || dInputProps === void 0 ? void 0 : dInputProps.onFocus) === null || _a === void 0 ? void 0 : _a.call(dInputProps, e);
                                            fvOnFocus(e);
                                            setIsFocus(true);
                                        }, onBlur: (e) => {
                                            var _a;
                                            (_a = dInputProps === null || dInputProps === void 0 ? void 0 : dInputProps.onBlur) === null || _a === void 0 ? void 0 : _a.call(dInputProps, e);
                                            fvOnBlur(e);
                                            setIsFocus(false);
                                        }, onKeyDown: (e) => {
                                            var _a;
                                            (_a = dInputProps === null || dInputProps === void 0 ? void 0 : dInputProps.onKeyDown) === null || _a === void 0 ? void 0 : _a.call(dInputProps, e);
                                            fvOnKeyDown(e);
                                        }, dFormControl: dFormControl }))) })), !inputable &&
                                    (dContent ? (_jsx("div", Object.assign({ className: `${prefix}__content` }, { children: dContent }))) : dPlaceholder ? (_jsx("div", Object.assign({ className: `${prefix}__placeholder-wrapper` }, { children: _jsx("div", Object.assign({ className: `${prefix}__placeholder` }, { children: dPlaceholder })) }))) : null)] })), checkNodeExist(dSuffix) && (_jsx("div", Object.assign({ className: `${prefix}__suffix`, onClick: (e) => {
                                e.stopPropagation();
                            } }, { children: dSuffix }))), clearable && (_jsx("div", Object.assign({ className: `${prefix}__clear`, role: "button", "aria-label": t('Clear'), onClick: (e) => {
                                e.stopPropagation();
                                onClear === null || onClear === void 0 ? void 0 : onClear();
                            } }, { children: _jsx(CloseCircleFilled, {}) }))), _jsx("div", Object.assign({ className: getClassName(`${prefix}__icon`, {
                                'is-arrow-up': !dLoading && !inputable && dVisible,
                            }), style: {
                                opacity: clearable ? 0 : 1,
                            } }, { children: dLoading ? _jsx(LoadingOutlined, { dSpin: true }) : inputable ? _jsx(SearchOutlined, {}) : _jsx(DownOutlined, {}) }))] })) })), containerEl &&
                ReactDOM.createPortal(_jsx(DTransition, Object.assign({ dIn: dVisible, dDuring: TTANSITION_DURING_POPUP, onEnterRendered: updatePosition, afterEnter: () => {
                        afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(true);
                    }, afterLeave: () => {
                        afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(false);
                    } }, { children: (state) => {
                        let transitionStyle = {};
                        switch (state) {
                            case 'enter':
                                transitionStyle = { transform: 'scaleY(0.7)', opacity: 0 };
                                break;
                            case 'entering':
                                transitionStyle = {
                                    transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_POPUP}ms ease-out`).join(', '),
                                    transformOrigin,
                                };
                                break;
                            case 'leaving':
                                transitionStyle = {
                                    transform: 'scaleY(0.7)',
                                    opacity: 0,
                                    transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_POPUP}ms ease-in`).join(', '),
                                    transformOrigin,
                                };
                                break;
                            case 'leaved':
                                transitionStyle = { display: 'none' };
                                break;
                            default:
                                break;
                        }
                        return children({
                            sPopupRef: popupRef,
                            sStyle: Object.assign(Object.assign(Object.assign({}, popupPositionStyle), transitionStyle), { zIndex: maxZIndex }),
                            sOnMouseDown: preventBlur,
                            sOnMouseUp: preventBlur,
                        });
                    } })), containerEl)] }));
}
export const DSelectbox = React.forwardRef(Selectbox);
//# sourceMappingURL=Selectbox.js.map