import type { DNestedChildren } from '../../utils';
import type { DElementSelector } from '@react-devui/hooks/useElement';
import React from 'react';
export interface DAnchorItem {
    href: string;
    title?: React.ReactNode;
    target?: string;
}
export interface DAnchorRef {
    activeHref: string | null;
    updateAnchor: () => void;
}
export interface DAnchorProps<T extends DAnchorItem> extends Omit<React.HTMLAttributes<HTMLUListElement>, 'children'> {
    dList: DNestedChildren<T>[];
    dPage?: DElementSelector;
    dDistance?: number;
    dScrollBehavior?: 'instant' | 'smooth';
    dIndicator?: React.ReactNode | typeof DOT_INDICATOR | typeof LINE_INDICATOR;
    onItemClick?: (href: string, item: DNestedChildren<T>) => void;
}
declare const DOT_INDICATOR: unique symbol;
declare const LINE_INDICATOR: unique symbol;
declare function Anchor<T extends DAnchorItem>(props: DAnchorProps<T>, ref: React.ForwardedRef<DAnchorRef>): JSX.Element | null;
export declare const DAnchor: {
    <T extends DAnchorItem>(props: DAnchorProps<T> & React.RefAttributes<DAnchorRef>): ReturnType<typeof Anchor>;
    DOT_INDICATOR: typeof DOT_INDICATOR;
    LINE_INDICATOR: typeof LINE_INDICATOR;
};
export {};
