var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { isArray, isNull } from 'lodash';
import React, { useEffect, useRef } from 'react';
import { useAsync, useForceUpdate, useImmer } from '@react-devui/hooks';
import { dayjs } from '../../dayjs';
import { useDValue, useGeneralContext } from '../../hooks';
import { DDateInput } from '../_date-input';
import { useFormControl } from '../form';
import { deepCompareDate } from './utils';
function Builder(props, ref) {
    const { children, dClassNamePrefix, dFormControl, dModel, dFormat, dVisible, dSuffix, dPlaceholder, dOrder, dPlacement = 'bottom-left', dSize, dClearable = false, dRange = false, dDisabled = false, dPopupClassName, dInputProps, dInputRef, onModelChange, onVisibleChange, afterVisibleChange, onClear, onUpdatePanel } = props, restProps = __rest(props, ["children", "dClassNamePrefix", "dFormControl", "dModel", "dFormat", "dVisible", "dSuffix", "dPlaceholder", "dOrder", "dPlacement", "dSize", "dClearable", "dRange", "dDisabled", "dPopupClassName", "dInputProps", "dInputRef", "onModelChange", "onVisibleChange", "afterVisibleChange", "onClear", "onUpdatePanel"]);
    //#region Ref
    const { gSize, gDisabled } = useGeneralContext();
    //#endregion
    const dataRef = useRef({
        focusAnother: false,
        inputValue: ['', ''],
        rangeDate: [null, null],
    });
    const asyncCapture = useAsync();
    const forceUpdate = useForceUpdate();
    const size = dSize !== null && dSize !== void 0 ? dSize : gSize;
    const disabled = dDisabled || gDisabled || (dFormControl === null || dFormControl === void 0 ? void 0 : dFormControl.control.disabled);
    const [dInputRefLeft, dInputRefRight] = (dRange ? dInputRef !== null && dInputRef !== void 0 ? dInputRef : [] : [dInputRef]);
    const [visible, changeVisible] = useDValue(false, dVisible, onVisibleChange);
    const formControlInject = useFormControl(dFormControl);
    const [_value, _changeValue] = useDValue(null, dModel, onModelChange, (a, b) => deepCompareDate(a, b, dFormat), formControlInject);
    const changeValue = (date, position) => {
        dataRef.current.inputValue[position === 'start' ? 0 : 1] = dayjs(date).format(dFormat);
        if (dRange) {
            if (isNull(_value)) {
                dataRef.current.rangeDate[position === 'start' ? 0 : 1] = date;
                if (dataRef.current.rangeDate.every((v) => !isNull(v))) {
                    dataRef.current.focusAnother = dOrder(dataRef.current.rangeDate);
                    if (dataRef.current.focusAnother) {
                        dataRef.current.rangeDate.reverse();
                        dataRef.current.inputValue.reverse();
                    }
                    _changeValue(dataRef.current.rangeDate);
                }
            }
            else {
                _changeValue((draft) => {
                    draft[position === 'start' ? 0 : 1] = date;
                    dataRef.current.focusAnother = dOrder(draft);
                    if (dataRef.current.focusAnother) {
                        draft.reverse();
                        dataRef.current.inputValue.reverse();
                    }
                });
            }
        }
        else {
            _changeValue(date);
        }
        forceUpdate();
    };
    let [valueLeft, valueRight = null] = (isArray(_value) ? _value : [_value, null]);
    if (dRange) {
        if (isNull(_value)) {
            [valueLeft, valueRight] = dataRef.current.rangeDate;
        }
        else {
            dataRef.current.rangeDate = [null, null];
        }
    }
    const [isFocus, setIsFocus] = useImmer([false, false]);
    const handleFocusChange = (focus, position) => {
        var _a, _b;
        (_b = (_a = dataRef.current).clearTid) === null || _b === void 0 ? void 0 : _b.call(_a);
        if (focus) {
            setIsFocus((draft) => {
                draft.fill(false);
                draft[position === 'start' ? 0 : 1] = true;
            });
        }
        else {
            dataRef.current.clearTid = asyncCapture.setTimeout(() => {
                setIsFocus([false, false]);
            }, 20);
        }
    };
    if (!isFocus[0]) {
        dataRef.current.inputValue[0] = isNull(valueLeft) ? '' : dayjs(valueLeft).format(dFormat);
    }
    if (!isFocus[1]) {
        dataRef.current.inputValue[1] = isNull(valueRight) ? '' : dayjs(valueRight).format(dFormat);
    }
    useEffect(() => {
        if (dataRef.current.focusAnother && document.activeElement) {
            const el = document.activeElement.parentElement;
            for (let index = 0; index < el.childElementCount; index++) {
                const element = el.children.item(index);
                if (element.tagName.toLowerCase() === 'input' && element !== document.activeElement) {
                    element.focus({ preventScroll: true });
                    break;
                }
            }
        }
        dataRef.current.focusAnother = false;
    });
    const getInputProps = (isLeft) => {
        const [dInputPropsLeft, dInputPropsRight] = (dRange ? dInputProps !== null && dInputProps !== void 0 ? dInputProps : [] : [dInputProps]);
        const inputProps = isLeft ? dInputPropsLeft : dInputPropsRight;
        const index = isLeft ? 0 : 1;
        const position = isLeft ? 'start' : 'end';
        const value = isLeft ? valueLeft : valueRight;
        return Object.assign(Object.assign({}, inputProps), { value: dataRef.current.inputValue[index], placeholder: isLeft ? dPlaceholder[0] : dPlaceholder[1], onChange: (e) => {
                var _a;
                (_a = inputProps === null || inputProps === void 0 ? void 0 : inputProps.onChange) === null || _a === void 0 ? void 0 : _a.call(inputProps, e);
                const val = e.currentTarget.value;
                dataRef.current.inputValue[index] = val;
                if (dayjs(val, dFormat, true).isValid()) {
                    const date = dayjs(val, dFormat).toDate();
                    onUpdatePanel === null || onUpdatePanel === void 0 ? void 0 : onUpdatePanel(date);
                    changeValue(date, position);
                }
                forceUpdate();
            }, onKeyDown: (e) => {
                var _a;
                (_a = inputProps === null || inputProps === void 0 ? void 0 : inputProps.onKeyDown) === null || _a === void 0 ? void 0 : _a.call(inputProps, e);
                if (e.code === 'Enter') {
                    if (dayjs(dataRef.current.inputValue[index], dFormat, true).isValid()) {
                        if (dRange) {
                            if (isNull(isLeft ? valueRight : valueLeft)) {
                                dataRef.current.focusAnother = true;
                            }
                            else {
                                changeVisible(false);
                            }
                        }
                        else {
                            changeVisible(false);
                        }
                    }
                    else {
                        dataRef.current.inputValue[index] = isNull(value) ? '' : dayjs(value).format(dFormat);
                    }
                    forceUpdate();
                }
            }, onFocus: (e) => {
                var _a;
                (_a = inputProps === null || inputProps === void 0 ? void 0 : inputProps.onFocus) === null || _a === void 0 ? void 0 : _a.call(inputProps, e);
                if (value && isFocus[isLeft ? 1 : 0]) {
                    onUpdatePanel === null || onUpdatePanel === void 0 ? void 0 : onUpdatePanel(value);
                }
                handleFocusChange(true, position);
            }, onBlur: (e) => {
                var _a;
                (_a = inputProps === null || inputProps === void 0 ? void 0 : inputProps.onBlur) === null || _a === void 0 ? void 0 : _a.call(inputProps, e);
                handleFocusChange(false, position);
            } });
    };
    const latestFocus = useRef('start');
    if (isFocus[0]) {
        latestFocus.current = 'start';
    }
    if (isFocus[1]) {
        latestFocus.current = 'end';
    }
    return (_jsx(DDateInput, Object.assign({}, restProps, { ref: ref, dClassNamePrefix: dClassNamePrefix, dFormControl: dFormControl, dVisible: visible, dPlacement: dPlacement, dSuffix: dSuffix, dSize: size, dRange: dRange, dClearable: dClearable && !isNull(_value), dDisabled: disabled, dInputProps: [getInputProps(true), getInputProps(false)], dInputRef: [dInputRefLeft, dInputRefRight], onVisibleChange: changeVisible, afterVisibleChange: afterVisibleChange, onClear: () => {
            onClear === null || onClear === void 0 ? void 0 : onClear();
            _changeValue(null);
        } }, { children: ({ diPopupRef, diStyle, diOnMouseDown, diOnMouseUp }) => (_jsx("div", Object.assign({ ref: diPopupRef, className: dPopupClassName, style: diStyle, onMouseDown: diOnMouseDown, onMouseUp: diOnMouseUp }, { children: children({
                pbDate: latestFocus.current === 'start' ? valueLeft : valueRight,
                pbCurrentDate: dRange ? (isNull(_value) ? dataRef.current.rangeDate : _value) : [valueLeft, null],
                pbPosition: latestFocus.current,
                changeValue: (date) => {
                    if (isArray(date)) {
                        dataRef.current.inputValue = date.map((d) => dayjs(d).format(dFormat));
                        _changeValue(date);
                    }
                    else {
                        changeValue(date, latestFocus.current);
                    }
                },
            }) }))) })));
}
export const DBuilder = React.forwardRef(Builder);
//# sourceMappingURL=Builder.js.map