var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { isUndefined } from 'lodash';
import React, { useMemo } from 'react';
import { getClassName } from '@react-devui/utils';
import { usePrefixConfig, useComponentConfig } from '../../hooks';
import { registerComponentMate } from '../../utils';
import { useMediaMatch } from '../grid';
import { DFormGroup, DFormGroupContext } from './FormGroup';
import { DFormItem } from './FormItem';
export const DFormContext = React.createContext(null);
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DForm' });
export const DForm = (props) => {
    var _a;
    const _b = useComponentConfig(COMPONENT_NAME, props), { children, dForm, dLabelWidth, dLabelColon, dRequiredType = 'required', dLayout = 'horizontal', dInlineSpan = 6, dFeedbackIcon = false, dSize, dResponsiveProps } = _b, restProps = __rest(_b, ["children", "dForm", "dLabelWidth", "dLabelColon", "dRequiredType", "dLayout", "dInlineSpan", "dFeedbackIcon", "dSize", "dResponsiveProps"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    const mediaMatch = useMediaMatch();
    const contextValue = useMemo(() => {
        const contextValue = {
            gInstance: dForm,
            gBreakpointMatchs: mediaMatch,
            gLabelWidth: dLabelWidth !== null && dLabelWidth !== void 0 ? dLabelWidth : 150,
            gLabelColon: dLabelColon !== null && dLabelColon !== void 0 ? dLabelColon : true,
            gRequiredType: dRequiredType,
            gLayout: dLayout,
            gInlineSpan: dInlineSpan,
            gFeedbackIcon: dFeedbackIcon,
            gSize: dSize,
        };
        if (dResponsiveProps) {
            const mergeProps = (point, targetKey, sourceKey) => {
                const value = dResponsiveProps[point][sourceKey];
                if (!isUndefined(value)) {
                    contextValue[targetKey] = value;
                }
            };
            for (const breakpoint of mediaMatch) {
                if (breakpoint in dResponsiveProps) {
                    mergeProps(breakpoint, 'gLabelWidth', 'dLabelWidth');
                    mergeProps(breakpoint, 'gLayout', 'dLayout');
                    mergeProps(breakpoint, 'gInlineSpan', 'dInlineSpan');
                    break;
                }
            }
        }
        contextValue.gLabelWidth = dLabelWidth !== null && dLabelWidth !== void 0 ? dLabelWidth : (contextValue.gLayout === 'vertical' ? '100%' : 150);
        contextValue.gLabelColon = dLabelColon !== null && dLabelColon !== void 0 ? dLabelColon : (contextValue.gLayout === 'vertical' ? false : true);
        return contextValue;
    }, [dForm, mediaMatch, dLabelWidth, dLabelColon, dRequiredType, dLayout, dInlineSpan, dFeedbackIcon, dSize, dResponsiveProps]);
    return (_jsx(DFormContext.Provider, Object.assign({ value: contextValue }, { children: _jsx(DFormGroupContext.Provider, Object.assign({ value: dForm.form }, { children: _jsx("form", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}form`, {
                    [`${dPrefix}form--${dSize}`]: dSize,
                    [`${dPrefix}form--${dLayout}`]: dLayout,
                }), autoComplete: (_a = restProps.autoComplete) !== null && _a !== void 0 ? _a : 'off', onSubmit: (e) => {
                    var _a;
                    (_a = restProps.onSubmit) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                    e.preventDefault();
                    e.stopPropagation();
                } }, { children: children })) })) })));
};
DForm.Group = DFormGroup;
DForm.Item = DFormItem;
//# sourceMappingURL=Form.js.map