import type { DBreakpoints } from '../grid';
import type { AbstractControl } from './form-control';
import React from 'react';
export interface DFormControl {
    control: AbstractControl;
    wrapperAttrs: {
        [index: string]: boolean;
    };
    inputAttrs: {
        'aria-invalid'?: boolean;
        'aria-describedby'?: string;
    };
}
export declare type DValidateStatus = 'success' | 'warning' | 'error' | 'pending';
export declare type DErrorInfo = string | {
    message: string;
    status: 'warning' | 'error';
} | {
    [index: string]: string | {
        message: string;
        status: 'warning' | 'error';
    };
};
export interface DFormItemProps<T extends {
    [index: string]: DErrorInfo;
}> extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    children: React.ReactNode | ((formControls: {
        [N in keyof T]: DFormControl;
    }) => React.ReactNode);
    dFormControls?: T;
    dLabel?: React.ReactNode;
    dLabelWidth?: number | string;
    dLabelExtra?: ({
        title: string;
        icon?: React.ReactElement;
    } | string)[];
    dShowRequired?: boolean;
    dSpan?: number | string | true;
    dResponsiveProps?: Partial<Record<DBreakpoints, Pick<DFormItemProps<T>, 'dLabelWidth' | 'dSpan'>>>;
}
export declare function DFormItem<T extends {
    [index: string]: DErrorInfo;
}>(props: DFormItemProps<T>): JSX.Element | null;
