var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { isUndefined } from 'lodash';
import { useEffect, useRef, useState } from 'react';
import { useAsync, useForceUpdate, useForkRef } from '@react-devui/hooks';
import { CloseCircleFilled, DCustomIcon, EyeInvisibleOutlined, EyeOutlined } from '@react-devui/icons';
import { checkNodeExist, getClassName } from '@react-devui/utils';
import { usePrefixConfig, useComponentConfig, useTranslation, useGeneralContext, useDValue } from '../../hooks';
import { registerComponentMate } from '../../utils';
import { DBaseDesign } from '../_base-design';
import { DBaseInput } from '../_base-input';
import { useFormControl } from '../form';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DInput' });
export function DInput(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { dType, dMax, dMin, dStep, dInteger = false, dPlaceholder, dDisabled = false, dFormControl, dModel, dPrefix: dPrefixNode, dSuffix, dPasswordToggle = true, dNumbetButton = true, dClearable = false, dSize, dInputProps, dInputRef, onModelChange } = _a, restProps = __rest(_a, ["dType", "dMax", "dMin", "dStep", "dInteger", "dPlaceholder", "dDisabled", "dFormControl", "dModel", "dPrefix", "dSuffix", "dPasswordToggle", "dNumbetButton", "dClearable", "dSize", "dInputProps", "dInputRef", "onModelChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    const { gSize, gDisabled } = useGeneralContext();
    //#endregion
    //#region Ref
    const inputRef = useRef(null);
    //#endregion
    const combineInputRef = useForkRef(inputRef, dInputRef);
    const dataRef = useRef({
        showValue: '',
        prevValue: '',
    });
    const asyncCapture = useAsync();
    const [t] = useTranslation();
    const forceUpdate = useForceUpdate();
    const formControlInject = useFormControl(dFormControl);
    const [_value, changeValue] = useDValue('', dModel, onModelChange, undefined, formControlInject);
    if (_value !== dataRef.current.prevValue) {
        dataRef.current.showValue = dataRef.current.prevValue = _value;
    }
    const [isFocus, setIsFocus] = useState(false);
    const [password, setPassword] = useState(true);
    const size = dSize !== null && dSize !== void 0 ? dSize : gSize;
    const disabled = dDisabled || gDisabled || (dFormControl === null || dFormControl === void 0 ? void 0 : dFormControl.control.disabled);
    const changeNumber = (isIncrease = true) => {
        var _a, _b;
        const stepVal = dStep !== null && dStep !== void 0 ? dStep : 1;
        const newVal = (() => {
            let val = Number(dataRef.current.showValue);
            if (Number.isNaN(val)) {
                return 0;
            }
            if (dInteger && !Number.isInteger(val)) {
                val = Math.round(val);
            }
            return isIncrease ? val + stepVal : val - stepVal;
        })();
        changeValue(Math.max(dMin !== null && dMin !== void 0 ? dMin : -Infinity, Math.min(dMax !== null && dMax !== void 0 ? dMax : Infinity, newVal)).toFixed((_b = (_a = stepVal.toString().split('.')[1]) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0));
    };
    const handleNumberMouseDown = (isIncrease = true) => {
        const loop = () => {
            changeNumber(isIncrease);
            dataRef.current.clearLoop = asyncCapture.setTimeout(() => loop(), 50);
        };
        dataRef.current.clearTid = asyncCapture.setTimeout(() => loop(), 400);
    };
    const handleNumberMouseUp = () => {
        var _a, _b, _c, _d;
        (_b = (_a = dataRef.current).clearLoop) === null || _b === void 0 ? void 0 : _b.call(_a);
        (_d = (_c = dataRef.current).clearTid) === null || _d === void 0 ? void 0 : _d.call(_c);
    };
    const preventBlur = (e) => {
        if (e.target !== inputRef.current && e.button === 0) {
            e.preventDefault();
        }
    };
    useEffect(() => {
        const [asyncGroup, asyncId] = asyncCapture.createGroup();
        asyncGroup.fromEvent(window, 'mouseup').subscribe({
            next: () => {
                handleNumberMouseUp();
            },
        });
        return () => {
            asyncCapture.deleteGroup(asyncId);
        };
    }, [asyncCapture]);
    return (_jsx(DBaseDesign, Object.assign({ dCompose: { active: isFocus, disabled: disabled }, dFormControl: dFormControl }, { children: _jsxs("div", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}input`, {
                [`${dPrefix}input--${size}`]: size,
                [`${dPrefix}input--number`]: dType === 'number',
                'is-disabled': disabled,
                'is-focus': isFocus,
            }), onMouseDown: (e) => {
                var _a;
                (_a = restProps.onMouseDown) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                preventBlur(e);
            }, onMouseUp: (e) => {
                var _a;
                (_a = restProps.onMouseUp) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                preventBlur(e);
            }, onClick: (e) => {
                var _a, _b;
                (_a = restProps.onClick) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                (_b = inputRef.current) === null || _b === void 0 ? void 0 : _b.focus({ preventScroll: true });
            } }, { children: [checkNodeExist(dPrefixNode) && _jsx("div", Object.assign({ className: `${dPrefix}input__prefix` }, { children: dPrefixNode })), _jsx(DBaseInput, Object.assign({}, dInputProps, { ref: combineInputRef, className: getClassName(dInputProps === null || dInputProps === void 0 ? void 0 : dInputProps.className, `${dPrefix}input__input`), placeholder: dPlaceholder, value: dataRef.current.showValue, type: dType === 'password' ? (password ? 'password' : 'text') : dType, max: dMax, min: dMin, step: dStep, disabled: disabled, onChange: (e) => {
                        var _a;
                        (_a = dInputProps === null || dInputProps === void 0 ? void 0 : dInputProps.onChange) === null || _a === void 0 ? void 0 : _a.call(dInputProps, e);
                        dataRef.current.showValue = e.currentTarget.value;
                        forceUpdate();
                        const val = Number(dataRef.current.showValue);
                        if ((!isUndefined(dMax) && val > dMax) || (!isUndefined(dMin) && val < dMin) || (dInteger && !Number.isInteger(val))) {
                            return;
                        }
                        changeValue(dataRef.current.showValue);
                    }, onFocus: (e) => {
                        var _a;
                        (_a = dInputProps === null || dInputProps === void 0 ? void 0 : dInputProps.onFocus) === null || _a === void 0 ? void 0 : _a.call(dInputProps, e);
                        setIsFocus(true);
                    }, onBlur: (e) => {
                        var _a;
                        (_a = dInputProps === null || dInputProps === void 0 ? void 0 : dInputProps.onBlur) === null || _a === void 0 ? void 0 : _a.call(dInputProps, e);
                        if (dType === 'number') {
                            if (dataRef.current.showValue) {
                                let val = Number(dataRef.current.showValue);
                                if (!isUndefined(dMax) && val > dMax) {
                                    val = dMax;
                                }
                                if (!isUndefined(dMin) && val < dMin) {
                                    val = dMin;
                                }
                                if (dInteger && !Number.isInteger(val)) {
                                    val = Math.round(val);
                                }
                                changeValue(val.toString());
                            }
                            else {
                                changeValue('');
                            }
                        }
                        dataRef.current.showValue = _value;
                        setIsFocus(false);
                    }, dFormControl: dFormControl })), dClearable && !disabled && (_jsx("div", Object.assign({ className: `${dPrefix}input__clear`, style: { opacity: dataRef.current.showValue.length > 0 ? 1 : 0 }, role: "button", "aria-label": t('Clear'), onClick: () => {
                        changeValue('');
                    } }, { children: _jsx(CloseCircleFilled, {}) }))), dType === 'password' && !disabled && (_jsx("div", Object.assign({ className: `${dPrefix}input__password`, role: "button", "aria-label": t('Input', password ? 'Password is not visible' : 'Password is visible'), onClick: () => {
                        if (dPasswordToggle) {
                            setPassword(!password);
                        }
                    } }, { children: password ? _jsx(EyeInvisibleOutlined, {}) : _jsx(EyeOutlined, {}) }))), dType === 'number' && dNumbetButton && !disabled && (_jsxs("div", Object.assign({ className: `${dPrefix}input__number-container` }, { children: [_jsx("div", Object.assign({ className: `${dPrefix}input__number`, role: "button", "aria-label": t('Input', 'Increase number'), onMouseDown: (e) => {
                                if (e.button === 0) {
                                    handleNumberMouseDown();
                                }
                            }, onTouchStart: () => {
                                handleNumberMouseDown();
                            }, onTouchEnd: () => {
                                handleNumberMouseUp();
                            }, onClick: () => {
                                changeNumber();
                            } }, { children: _jsx(DCustomIcon, Object.assign({ viewBox: "0 0 24 24" }, { children: _jsx("path", { d: "M19.637 16.4369C19.0513 17.0227 18.1015 17.0227 17.5157 16.4369L11.8589 10.7801L6.20202 16.4369C5.61623 17.0227 4.66648 17.0227 4.0807 16.4369C3.49491 15.8511 3.49491 14.9014 4.0807 14.3156L10.7982 7.59809C11.384 7.01231 12.3337 7.01231 12.9195 7.59809L19.637 14.3156C20.2228 14.9014 20.2228 15.8511 19.637 16.4369Z" }) })) })), _jsx("div", Object.assign({ className: `${dPrefix}input__number`, role: "button", "aria-label": t('Input', 'Decrease number'), onMouseDown: (e) => {
                                if (e.button === 0) {
                                    handleNumberMouseDown(false);
                                }
                            }, onTouchStart: () => {
                                handleNumberMouseDown(false);
                            }, onTouchEnd: () => {
                                handleNumberMouseUp();
                            }, onClick: () => {
                                changeNumber(false);
                            } }, { children: _jsx(DCustomIcon, Object.assign({ viewBox: "0 0 24 24" }, { children: _jsx("path", { d: "M4.08045 7.59809C4.66624 7.01231 5.61599 7.01231 6.20177 7.59809L11.8586 13.2549L17.5155 7.59809C18.1013 7.01231 19.051 7.01231 19.6368 7.59809C20.2226 8.18388 20.2226 9.13363 19.6368 9.71941L12.9193 16.4369C12.3335 17.0227 11.3838 17.0227 10.798 16.4369L4.08045 9.71941C3.49467 9.13363 3.49467 8.18388 4.08045 7.59809Z" }) })) }))] }))), checkNodeExist(dSuffix) && _jsx("div", Object.assign({ className: `${dPrefix}input__suffix` }, { children: dSuffix }))] })) })));
}
//# sourceMappingURL=Input.js.map