var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { useState, useRef, useEffect, useCallback } from 'react';
import { useElement } from '@react-devui/hooks';
import { CaretDownOutlined } from '@react-devui/icons';
import { checkNodeExist, getClassName, getHorizontalSidePosition, getOriginalSize, getVerticalSidePosition } from '@react-devui/utils';
import { usePrefixConfig, useTranslation, useMaxIndex } from '../../hooks';
import { TTANSITION_DURING_BASE, TTANSITION_DURING_POPUP } from '../../utils';
import { DPopup } from '../_popup';
import { DCollapseTransition, DTransition } from '../_transition';
export function DSub(props) {
    const { children, dId, dDisabled, dPosinset, dMode, dInNav, dActive, dExpand, dFocusVisible, dList, dPopupVisible, dPopupState, dEmpty, dTrigger, dIcon, dStep, dSpace, dLevel = 0, onVisibleChange, onSubClick, updatePosition$, } = props;
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const popupRef = useRef(null);
    const liRef = useRef(null);
    //#endregion
    const [t] = useTranslation();
    const inHorizontalNav = dMode === 'horizontal' && dInNav;
    const containerEl = useElement(() => {
        let el = document.getElementById(`${dPrefix}menu-root`);
        if (!el) {
            el = document.createElement('div');
            el.id = `${dPrefix}menu-root`;
            document.body.appendChild(el);
        }
        return el;
    });
    const [popupPositionStyle, setPopupPositionStyle] = useState({
        top: -9999,
        left: -9999,
    });
    const [transformOrigin, setTransformOrigin] = useState();
    const updatePosition = useCallback(() => {
        if (popupRef.current && liRef.current) {
            const size = getOriginalSize(popupRef.current);
            const height = size.height;
            let width = size.width;
            if (inHorizontalNav) {
                width = liRef.current.getBoundingClientRect().width - 32;
            }
            const { top, left, transformOrigin } = inHorizontalNav
                ? getVerticalSidePosition(liRef.current, { width, height }, 'bottom-left', 12)
                : getHorizontalSidePosition(liRef.current, { width, height }, 'right', dInNav ? 10 : 14);
            setPopupPositionStyle({
                top,
                left: inHorizontalNav ? left + 16 : left,
                width: inHorizontalNav ? width : undefined,
            });
            setTransformOrigin(transformOrigin);
        }
    }, [dInNav, inHorizontalNav]);
    const maxZIndex = useMaxIndex(dPopupVisible);
    const iconRotate = (() => {
        if (dMode === 'vertical' && dExpand) {
            return 180;
        }
        if (dMode !== 'vertical' && !inHorizontalNav) {
            return -90;
        }
        return undefined;
    })();
    useEffect(() => {
        if (dPopupVisible) {
            const ob = updatePosition$.subscribe({
                next: () => {
                    updatePosition();
                },
            });
            return () => {
                ob.unsubscribe();
            };
        }
    }, [dPopupVisible, updatePosition, updatePosition$]);
    return (_jsx(DCollapseTransition, Object.assign({ dSize: 0, dIn: dMode === 'vertical' || !dInNav ? dExpand : false, dDuring: TTANSITION_DURING_BASE, dStyles: {
            entering: {
                transition: ['height', 'padding', 'margin'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-out`).join(', '),
            },
            leaving: {
                transition: ['height', 'padding', 'margin'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-in`).join(', '),
            },
            leaved: { display: 'none' },
        } }, { children: (collapseRef, collapseStyle, collapseState) => (_jsxs(_Fragment, { children: [_jsx(DPopup, Object.assign({ dPopup: (_a) => {
                        var { pOnClick, pOnMouseEnter, pOnMouseLeave } = _a, restPProps = __rest(_a, ["pOnClick", "pOnMouseEnter", "pOnMouseLeave"]);
                        return (_jsx(DTransition, Object.assign({ dIn: dPopupVisible, dDuring: TTANSITION_DURING_POPUP, onEnterRendered: updatePosition }, { children: (popupState) => {
                                let popupTransitionStyle = {};
                                switch (popupState) {
                                    case 'enter':
                                        popupTransitionStyle = { transform: inHorizontalNav ? 'scaleY(0.7)' : 'scale(0)', opacity: 0 };
                                        break;
                                    case 'entering':
                                        popupTransitionStyle = {
                                            transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_POPUP}ms ease-out`).join(', '),
                                            transformOrigin,
                                        };
                                        break;
                                    case 'leaving':
                                        popupTransitionStyle = {
                                            transform: inHorizontalNav ? 'scaleY(0.7)' : 'scale(0)',
                                            opacity: 0,
                                            transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_POPUP}ms ease-in`).join(', '),
                                            transformOrigin,
                                        };
                                        break;
                                    case 'leaved':
                                        popupTransitionStyle = { display: 'none' };
                                        break;
                                    default:
                                        break;
                                }
                                return (_jsx("ul", Object.assign({}, restPProps, { ref: popupRef, className: getClassName(`${dPrefix}menu__sub-list`, `${dPrefix}menu__sub-list--popup`), style: Object.assign(Object.assign(Object.assign({}, popupPositionStyle), popupTransitionStyle), { minWidth: inHorizontalNav ? undefined : 160, zIndex: maxZIndex }), role: "menu", "aria-labelledby": dId, onClick: pOnClick, onMouseEnter: pOnMouseEnter, onMouseLeave: pOnMouseLeave }, { children: dEmpty ? (_jsx("div", Object.assign({ className: `${dPrefix}menu__empty`, style: { paddingLeft: dSpace + dLevel * dStep } }, { children: t('No Data') }))) : (dList) })));
                            } })));
                    }, dVisible: dPopupState, dContainer: containerEl, dDisabled: dDisabled || dMode === 'vertical', dTrigger: dTrigger, dUpdatePosition: updatePosition, onVisibleChange: onVisibleChange }, { children: (_a) => {
                        var { pOnClick, pOnMouseEnter, pOnMouseLeave } = _a, restPProps = __rest(_a, ["pOnClick", "pOnMouseEnter", "pOnMouseLeave"]);
                        return (_jsxs("li", Object.assign({}, restPProps, { ref: liRef, id: dId, className: getClassName(`${dPrefix}menu__item`, `${dPrefix}menu__item--sub`, {
                                [`${dPrefix}menu__item--horizontal`]: inHorizontalNav,
                                [`${dPrefix}menu__item--icon`]: dMode === 'icon' && dInNav,
                                'is-active': dActive,
                                'is-expand': dMode === 'vertical' ? dExpand : dPopupVisible,
                                'is-disabled': dDisabled,
                            }), style: { paddingLeft: dSpace + dLevel * dStep }, role: "menuitem", "aria-haspopup": true, "aria-expanded": dMode === 'vertical' ? dExpand : dPopupVisible, "aria-disabled": dDisabled, onClick: (e) => {
                                pOnClick === null || pOnClick === void 0 ? void 0 : pOnClick(e);
                                onSubClick(e);
                            }, onMouseEnter: pOnMouseEnter, onMouseLeave: pOnMouseLeave }, { children: [dFocusVisible && _jsx("div", { className: `${dPrefix}focus-outline` }), _jsx("div", Object.assign({ className: getClassName(`${dPrefix}menu__indicator`, {
                                        [`${dPrefix}menu__indicator--first`]: dPosinset[0] === 0 && dPosinset[1] > 1,
                                        [`${dPrefix}menu__indicator--last`]: dPosinset[0] === dPosinset[1] - 1 && dPosinset[1] > 1,
                                    }) }, { children: _jsx("div", { style: { backgroundColor: dLevel === 0 ? 'transparent' : undefined } }) })), checkNodeExist(dIcon) && (_jsx("div", Object.assign({ className: `${dPrefix}menu__item-icon-wrapper` }, { children: _jsx("div", Object.assign({ className: `${dPrefix}menu__item-icon` }, { children: dIcon })) }))), _jsx("div", Object.assign({ className: `${dPrefix}menu__item-content` }, { children: children })), !inHorizontalNav && _jsx(CaretDownOutlined, { className: `${dPrefix}menu__sub-arrow`, dSize: 14, dRotate: iconRotate })] })));
                    } })), dMode !== 'vertical' && (collapseState === 'leaved' || !dInNav) ? null : (_jsx("ul", Object.assign({ ref: collapseRef, className: `${dPrefix}menu__sub-list`, style: collapseStyle, role: "menu", "aria-labelledby": dId }, { children: dEmpty ? (_jsx("div", Object.assign({ className: `${dPrefix}menu__empty`, style: { paddingLeft: dSpace + (dLevel + 1) * dStep } }, { children: t('No Data') }))) : (dList) })))] })) })));
}
//# sourceMappingURL=Sub.js.map