/// <reference types="react" />
import { Subject } from 'rxjs';
export interface DNotificationProps extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    dType?: 'success' | 'warning' | 'error' | 'info';
    dIcon?: React.ReactNode;
    dTitle: React.ReactNode;
    dDescription?: React.ReactNode;
    dDuration?: number;
    dPlacement?: 'left-top' | 'right-top' | 'left-bottom' | 'right-bottom';
    dActions?: React.ReactNode[];
    dEscClosable?: boolean;
    onClose?: () => void;
    afterVisibleChange?: (visible: boolean) => void;
}
export declare const notificationSubject: {
    open$: Subject<{
        uniqueId: number;
        props: DNotificationProps;
    }>;
    close$: Subject<number>;
    rerender$: Subject<{
        uniqueId: number;
        props: DNotificationProps;
    }>;
    closeAll$: Subject<boolean>;
};
declare class Notification {
    private _uniqueId;
    constructor(_uniqueId: number);
    get uniqueId(): number;
    close(): void;
    rerender(props: DNotificationProps): void;
}
export declare class NotificationService {
    static get notifications(): Notification[];
    static open(props: DNotificationProps): Notification;
    static close(uniqueId: number): void;
    static rerender(uniqueId: number, props: DNotificationProps): void;
    static closeAll(animation?: boolean): void;
}
export declare function DNotification(props: DNotificationProps & {
    dVisible: boolean;
}): JSX.Element | null;
export {};
