import React from 'react';
import { DTableEmpty } from './TableEmpty';
import { DTableExpand } from './TableExpand';
import { DTableFilter } from './TableFilter';
import { DTableSearch } from './TableSearch';
import { DTableTd } from './TableTd';
import { DTableTh } from './TableTh';
export interface DTableContextData {
    gFixed: ('left' | 'right')[];
    gEllipsis: boolean;
}
export declare const DTableContext: React.Context<DTableContextData | null>;
export interface DTableProps extends React.HTMLAttributes<HTMLDivElement> {
    dBorder?: boolean;
    dEllipsis?: boolean;
}
declare function Table(props: DTableProps, ref: React.ForwardedRef<HTMLDivElement>): JSX.Element | null;
export declare const DTable: {
    (props: DTableProps & React.RefAttributes<HTMLDivElement>): ReturnType<typeof Table>;
    Th: typeof DTableTh;
    Td: typeof DTableTd;
    Empty: typeof DTableEmpty;
    Filter: typeof DTableFilter;
    Search: typeof DTableSearch;
    Expand: typeof DTableExpand;
};
export {};
