var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { isUndefined } from 'lodash';
import React, { useCallback, useId, useImperativeHandle, useRef, useState } from 'react';
import { useElement } from '@react-devui/hooks';
import { getClassName, getPopupPosition } from '@react-devui/utils';
import { usePrefixConfig, useComponentConfig, useMaxIndex, useDValue } from '../../hooks';
import { registerComponentMate } from '../../utils';
import { DPopup } from '../_popup';
import { DTransition } from '../_transition';
const TTANSITION_DURING = { enter: 86, leave: 100 };
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DTooltip' });
function Tooltip(props, ref) {
    var _a;
    const _b = useComponentConfig(COMPONENT_NAME, props), { children, dVisible, dTrigger = 'hover', dTitle, dContainer, dPlacement = 'top', dEscClosable = true, dArrow = true, dDisabled = false, dDistance = 10, dMouseEnterDelay = 150, dMouseLeaveDelay = 200, dZIndex, onVisibleChange, afterVisibleChange } = _b, restProps = __rest(_b, ["children", "dVisible", "dTrigger", "dTitle", "dContainer", "dPlacement", "dEscClosable", "dArrow", "dDisabled", "dDistance", "dMouseEnterDelay", "dMouseLeaveDelay", "dZIndex", "onVisibleChange", "afterVisibleChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const popupRef = useRef(null);
    //#endregion
    const uniqueId = useId();
    const id = (_a = restProps.id) !== null && _a !== void 0 ? _a : `${dPrefix}tooltip-${uniqueId}`;
    const [visible, changeVisible] = useDValue(false, dVisible, onVisibleChange);
    const isFixed = isUndefined(dContainer);
    const maxZIndex = useMaxIndex(visible);
    const zIndex = (() => {
        if (isUndefined(dZIndex)) {
            if (isFixed) {
                return maxZIndex;
            }
            else {
                return `var(--${dPrefix}zindex-absolute)`;
            }
        }
        else {
            return dZIndex;
        }
    })();
    const containerEl = useElement(isFixed
        ? () => {
            let el = document.getElementById(`${dPrefix}tooltip-root`);
            if (!el) {
                el = document.createElement('div');
                el.id = `${dPrefix}tooltip-root`;
                document.body.appendChild(el);
            }
            return el;
        }
        : dContainer === false
            ? () => {
                var _a;
                const triggerEl = document.querySelector(`[aria-describedby="${id}"]`);
                return (_a = triggerEl === null || triggerEl === void 0 ? void 0 : triggerEl.parentElement) !== null && _a !== void 0 ? _a : null;
            }
            : dContainer);
    const [popupPositionStyle, setPopupPositionStyle] = useState({
        top: -9999,
        left: -9999,
    });
    const [placement, setPlacement] = useState(dPlacement);
    const [transformOrigin, setTransformOrigin] = useState();
    const updatePosition = useCallback(() => {
        const triggerEl = document.querySelector(`[aria-describedby="${id}"]`);
        if (popupRef.current && triggerEl) {
            let currentPlacement = dPlacement;
            let space = [0, 0, 0, 0];
            if (!isFixed && containerEl) {
                const containerRect = containerEl.getBoundingClientRect();
                space = [
                    containerRect.top,
                    window.innerWidth - containerRect.left - containerRect.width,
                    window.innerHeight - containerRect.top - containerRect.height,
                    containerRect.left,
                ];
            }
            const position = getPopupPosition(popupRef.current, triggerEl, dPlacement, dDistance, space);
            if (position) {
                currentPlacement = position.placement;
                setPlacement(position.placement);
                setPopupPositionStyle({
                    top: position.top,
                    left: position.left,
                });
            }
            else {
                const position = getPopupPosition(popupRef.current, triggerEl, placement, dDistance);
                setPopupPositionStyle({
                    top: position.top,
                    left: position.left,
                });
            }
            let transformOrigin = 'center bottom';
            switch (currentPlacement) {
                case 'top':
                    transformOrigin = 'center bottom';
                    break;
                case 'top-left':
                    transformOrigin = '20px bottom';
                    break;
                case 'top-right':
                    transformOrigin = 'calc(100% - 20px) bottom';
                    break;
                case 'right':
                    transformOrigin = 'left center';
                    break;
                case 'right-top':
                    transformOrigin = 'left 12px';
                    break;
                case 'right-bottom':
                    transformOrigin = 'left calc(100% - 12px)';
                    break;
                case 'bottom':
                    transformOrigin = 'center top';
                    break;
                case 'bottom-left':
                    transformOrigin = '20px top';
                    break;
                case 'bottom-right':
                    transformOrigin = 'calc(100% - 20px) top';
                    break;
                case 'left':
                    transformOrigin = 'right center';
                    break;
                case 'left-top':
                    transformOrigin = 'right 12px';
                    break;
                case 'left-bottom':
                    transformOrigin = 'right calc(100% - 12px)';
                    break;
                default:
                    break;
            }
            setTransformOrigin(transformOrigin);
        }
    }, [containerEl, dDistance, dPlacement, id, isFixed, placement]);
    useImperativeHandle(ref, () => ({
        updatePosition,
    }), [updatePosition]);
    return (_jsx(DPopup, Object.assign({ dPopup: (_a) => {
            var { pOnClick, pOnMouseEnter, pOnMouseLeave } = _a, restPProps = __rest(_a, ["pOnClick", "pOnMouseEnter", "pOnMouseLeave"]);
            return (_jsx(DTransition, Object.assign({ dIn: visible, dDuring: TTANSITION_DURING, onEnterRendered: updatePosition, afterEnter: () => {
                    afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(true);
                }, afterLeave: () => {
                    afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(false);
                } }, { children: (state) => {
                    var _a;
                    let transitionStyle = {};
                    switch (state) {
                        case 'enter':
                            transitionStyle = { transform: 'scale(0.3)', opacity: 0 };
                            break;
                        case 'entering':
                            transitionStyle = {
                                transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING.enter}ms ease-out`).join(', '),
                                transformOrigin,
                            };
                            break;
                        case 'leaving':
                            transitionStyle = {
                                transform: 'scale(0.3)',
                                opacity: 0,
                                transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING.leave}ms ease-in`).join(', '),
                                transformOrigin,
                            };
                            break;
                        case 'leaved':
                            transitionStyle = { display: 'none' };
                            break;
                        default:
                            break;
                    }
                    return (_jsxs("div", Object.assign({}, restProps, restPProps, { ref: popupRef, id: id, className: getClassName(restProps.className, `${dPrefix}tooltip`, `${dPrefix}tooltip--` + placement), style: Object.assign(Object.assign(Object.assign(Object.assign({}, restProps.style), popupPositionStyle), transitionStyle), { zIndex }), role: (_a = restProps.role) !== null && _a !== void 0 ? _a : 'tooltip', onClick: (e) => {
                            var _a;
                            (_a = restProps.onClick) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            pOnClick === null || pOnClick === void 0 ? void 0 : pOnClick(e);
                        }, onMouseEnter: (e) => {
                            var _a;
                            (_a = restProps.onMouseEnter) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            pOnMouseEnter === null || pOnMouseEnter === void 0 ? void 0 : pOnMouseEnter(e);
                        }, onMouseLeave: (e) => {
                            var _a;
                            (_a = restProps.onMouseLeave) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            pOnMouseLeave === null || pOnMouseLeave === void 0 ? void 0 : pOnMouseLeave(e);
                        } }, { children: [dArrow && _jsx("div", { className: `${dPrefix}tooltip__arrow` }), dTitle] })));
                } })));
        }, dVisible: visible, dContainer: containerEl, dTrigger: dTrigger, dDisabled: dDisabled, dEscClosable: dEscClosable, dMouseEnterDelay: dMouseEnterDelay, dMouseLeaveDelay: dMouseLeaveDelay, dUpdatePosition: updatePosition, onVisibleChange: changeVisible }, { children: (_a) => {
            var _b;
            var { pOnClick, pOnMouseEnter, pOnMouseLeave } = _a, restPProps = __rest(_a, ["pOnClick", "pOnMouseEnter", "pOnMouseLeave"]);
            return React.cloneElement(children, Object.assign(Object.assign(Object.assign({}, children.props), restPProps), { 'aria-describedby': (_b = children.props['aria-describedby']) !== null && _b !== void 0 ? _b : id, onClick: (e) => {
                    var _a, _b;
                    (_b = (_a = children.props).onClick) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                    pOnClick === null || pOnClick === void 0 ? void 0 : pOnClick(e);
                }, onMouseEnter: (e) => {
                    var _a, _b;
                    (_b = (_a = children.props).onMouseEnter) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                    pOnMouseEnter === null || pOnMouseEnter === void 0 ? void 0 : pOnMouseEnter(e);
                }, onMouseLeave: (e) => {
                    var _a, _b;
                    (_b = (_a = children.props).onMouseLeave) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                    pOnMouseLeave === null || pOnMouseLeave === void 0 ? void 0 : pOnMouseLeave(e);
                } }));
        } })));
}
export const DTooltip = React.forwardRef(Tooltip);
//# sourceMappingURL=Tooltip.js.map