import type { DId } from '../../utils';
import type { DComboboxKeyboardSupportKey } from '../_keyboard-support';
import type { DTreeItem } from './Tree';
import type { AbstractTreeNode } from './node';
import type { Subject } from 'rxjs';
import React from 'react';
export interface DPanelProps<V extends DId, T extends DTreeItem<V>> extends Omit<React.HTMLAttributes<HTMLElement>, 'children'> {
    dGetGroupId: (value: V) => string;
    dGetItemId: (value: V) => string;
    dList: AbstractTreeNode<V, T>[];
    dExpandIds: Set<V>;
    dHeight: number;
    dPadding?: number;
    dFocusItem: AbstractTreeNode<V, T> | undefined;
    dCustomItem?: (item: T) => React.ReactNode;
    dShowLine?: boolean;
    dMultiple: boolean;
    dFocusVisible: boolean;
    onFocusChange: (node: AbstractTreeNode<V, T>) => void;
    onExpandChange: (node: AbstractTreeNode<V, T>) => void;
    onClickItem: (node: AbstractTreeNode<V, T>) => void;
    onKeyDown$: Subject<DComboboxKeyboardSupportKey | 'click'>;
}
export declare function DPanel<V extends DId, T extends DTreeItem<V>>(props: DPanelProps<V, T>): JSX.Element | null;
