import type { DNestedChildren, DId } from '../../utils';
import type { DFormControl } from '../form';
import React from 'react';
export interface DTreeItem<V extends DId> {
    label: string;
    value: V;
    loading?: boolean;
    disabled?: boolean;
}
export interface DTreeProps<V extends DId, T extends DTreeItem<V>> extends Omit<React.HTMLAttributes<HTMLElement>, 'children'> {
    dFormControl?: DFormControl;
    dList: DNestedChildren<T>[];
    dModel?: V | null | V[];
    dHeight?: number;
    dExpands?: V[];
    dExpandAll?: boolean;
    dShowLine?: boolean;
    dDisabled?: boolean;
    dMultiple?: boolean;
    dOnlyLeafSelectable?: boolean;
    dCustomItem?: (item: DNestedChildren<T>) => React.ReactNode;
    onModelChange?: (value: any, item: any) => void;
    onFirstExpand?: (value: V, item: DNestedChildren<T>) => void;
    onExpandsChange?: (ids: V[], items: DNestedChildren<T>[]) => void;
}
export declare function DTree<V extends DId, T extends DTreeItem<V>>(props: DTreeProps<V, T>): JSX.Element | null;
