import type { DId } from '../../utils';
import type { DFormControl } from '../form';
import React from 'react';
import { DUploadAction } from './UploadAction';
import { DUploadPictureButton } from './UploadPictureButton';
export declare type DUploadFileStatus = 'load' | 'error' | 'progress' | null;
export interface DUploadFile {
    uid: DId;
    name: string;
    url?: string;
    thumbUrl?: string;
    status: DUploadFileStatus;
    percent?: number;
    originFile?: File;
    response?: any;
    [index: string | symbol]: any;
}
export interface DUploadProps extends React.InputHTMLAttributes<HTMLInputElement> {
    children: React.ReactElement | null;
    dFormControl?: DFormControl;
    dModel?: DUploadFile[];
    dXHRRequest: {
        method?: string;
        url: string | URL;
        responseType?: XMLHttpRequestResponseType;
        header?: {
            [index: string]: string;
        };
        body?: (file: string | Blob) => Document | XMLHttpRequestBodyInit | null | undefined;
        custom?: (xhr: XMLHttpRequest) => void;
    };
    dListType?: 'list' | 'picture' | 'picture-list' | false;
    dDrag?: boolean;
    dMax?: number;
    dDefaultActions?: {
        preview?: (file: DUploadFile) => void;
        download?: (file: DUploadFile) => void;
    };
    dActions?: (file: DUploadFile, index: number) => React.ReactNode[];
    dCustomUpload?: (files: FileList) => void;
    dBeforeUpload?: (file: File, files: FileList) => boolean | string | Blob | Promise<boolean | string | Blob>;
    onModelChange?: (files: DUploadFile[], data: {
        type: 'add' | 'update' | 'remove';
        files: DUploadFile[];
    }) => void;
    onRemove?: (file: DUploadFile) => void;
}
declare function Upload(props: DUploadProps, ref: React.ForwardedRef<HTMLInputElement>): JSX.Element | null;
export declare const DUpload: {
    (props: DUploadProps & React.RefAttributes<HTMLInputElement>): ReturnType<typeof Upload>;
    Action: typeof DUploadAction;
    PictureButton: typeof DUploadPictureButton;
};
export {};
