import { isNull, isUndefined } from 'lodash';
import { useContext, useMemo } from 'react';
export function useContextOptional(Context) {
    const context = useContext(Context);
    const proxy = useMemo(() => {
        const handler = {
            get: function (...args) {
                if (args[1] === '__context_exist') {
                    return true;
                }
                return Reflect.get(...args);
            },
        };
        return isNull(context) || isUndefined(context) ? { __context_exist: false } : new Proxy(context, handler);
    }, [context]);
    return proxy;
}
//# sourceMappingURL=useContextOptional.js.map