import React, { useEffect, useState } from 'react';
import { useEventNotify } from '@react-devui/hooks';
import { usePrefixConfig } from './d-config';
export function useWave() {
    const dPrefix = usePrefixConfig();
    const wave$ = useEventNotify();
    const [node, setNode] = useState(null);
    useEffect(() => {
        const ob = wave$.subscribe({
            next: ({ color, animation }) => {
                setNode(React.createElement('div', {
                    key: Math.random(),
                    className: `${dPrefix}wave`,
                    style: {
                        [`--${dPrefix}wave-color`]: color,
                        animation,
                    },
                    onAnimationEnd: (e) => {
                        if (e.animationName === 'wave-fade-out') {
                            setNode(null);
                        }
                    },
                }));
            },
        });
        return () => {
            ob.unsubscribe();
        };
    }, [dPrefix, wave$]);
    return [node, (color, animation) => wave$.next({ color, animation })];
}
//# sourceMappingURL=useWave.js.map